  program
_abcdllmode_ equate(0)
_abclinkmode_ equate(1)
  map
   decorate(long hdc, string thetext)
   module('api')
     rectangle(long,long,long,long,long),long,pascal,name('rectangle'),proc
     TextOut(long, long, long,long, long),long,PASCAL,RAW,NAME('TextOutA'),proc
     createbrushindirect(long),long,pascal,raw,name('createbrushindirect'),proc
     setbkmode(long,long),long,raw,pascal,name('setbkmode'),proc
     setTextAlign(long,long),long,raw,pascal,name('settextalign'),proc
     settextcolor(long,long),long,raw,pascal,name('settextcolor'),proc
     GetDeviceCaps(LONG, SIGNED),SIGNED,PASCAL
     GetDesktopWindow(),LONG,PASCAL
     DeleteObject(LONG),LONG,PASCAL,proc
     SelectObject(LONG, LONG),LONG,PASCAL,proc
     ReleaseDC(LONG, LONG),SIGNED,PASCAL,Proc
     GetDC(LONG),LONG,PASCAL
   end
  end
include('imgdispcl.inc')
imgdispcl Class(imgdispcltype)
GetPreferedControlSize procedure(*long controlx, *long controly, *long controlwidth, *long controlheight),virtual
!above procedure calcs how big the image control should be after a window resize or in general before a repaint
end

window WINDOW('Custom Image Control'),AT(10,10,252,139),SYSTEM,GRAY,RESIZE,imm
       REGION,AT(9,5,234,125),USE(?Region1)
     END

sourcehwnd      LONG   !hwnd of the desktop or what ever the source is
sourcedc        LONG   !DC of the desktop or what ever the source is
sourcewidth     long       !width/height in pixels of the source image
sourceheight    long

  code
  !setup the CW window
  Open(window)
  0{prop:hide}='1'
  ImgDispCl.Init(thread(),?region1)
 
  !get source hwnd,DC, height,width
  sourcehwnd=getdesktopwindow()
  sourcedc=getdc(sourcehwnd)
  SourceWidth   = getdevicecaps(Sourcedc,8)
  sourceheight  = getdevicecaps(Sourcedc,10)
  If ImgDispCl.CopyToMemoryDC(sourcehwnd,sourcedc,sourcewidth,sourceheight)
    releasedc(sourcehwnd,sourcedc)
    close(window)
    ImgDispCl.kill()
    return
  else
    releasedc(sourcehwnd,sourcedc)
  end


  !add my text to the image
  decorate(ImgDispCl.hdcmem, 'Demo by Jim Kane')



  !unhide us
  0{prop:hide}=false

  !Size control, setup scrollbars and display
  ImgDispCl.ResizeControl()

  ImgDispCl.SubClassIt()


  !accept loop
  accept
    case event()
    Of event:Sized
    orof event:size
      ImgDispCl.ResizeControl()
    end
  end
  close(window)
  ImgDispCl.kill()


Decorate procedure(long phdc, string theText)
logbrush group
lpstyle long
lpcolor long
lpdummy long
  end
holdbrush long
hbrush long
bs_solid equate(0)
transparent equate(1)
opague equate(2)
translucent equate(3)
  code
  !make a brush so we can make a colored rectangle
  logbrush.lpstyle=bs_solid
  logbrush.lpcolor=color:yellow
  logbrush.lpdummy=0
  hbrush=createbrushIndirect(address(logbrush))
  If hbrush then
    holdbrush=selectobject(phdc,hbrush)
  end
  rectangle(phdc, 10,10,200,50)
  setbkmode(phdc,transparent)
  settextcolor(phdc,color:black)
  !settextalign,setbkcolor - use default
  Textout(phdc, 25,20, address(thetext),len(clip(thetext)))
  If holdbrush then
    hbrush=selectobject(phdc,holdbrush)
    if hbrush then deleteobject(hbrush).
  end
  return

ImgDispCl.GetPreferedControlSize procedure(*long controlx, *long controly, *long controlwidth, *long controlheight)
  code
  !calc prefered size of control based on window size
  ! resize the control to fill the window
  settarget(,SELF.windowthread)
  controlwidth=0{prop:Width}-10
  controlheight=0{prop:Height}-10
  controlx=5
  controly=5
  settarget()

