  MEMBER

_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

  INCLUDE('NEWCONTROL.INC'),ONCE
  INCLUDE('ABWINDOW.INC'),ONCE
  INCLUDE('ABUTIL.inc'),ONCE
  INCLUDE('ABMULTI2.inc'),once

  MAP
  END

BoxQueue          QUEUE,TYPE
CP                   &MultiBoxClass2    !Class pointer
NeedsUpdate          BYTE              !Mark for refresh
ID                   LONG
                     END

AllControls       QUEUE,TYPE
ControlNumber     SIGNED
ControlType       SHORT
QID               LONG
                     end


NewControl.AddControl  PROCEDURE(MultiBoxClass2 MBC,SIGNED controlnum,SIGNED numelements)     !Adds to queue
loopcounter signed
  CODE
  if records(self.bq) > 0
     get(Self.bq,records(self.bq))
     SELF.bq.id += 1
  else
     SELF.bq.id=1
  end
  SELF.bq.cp &= MBC
  SELF.bq.needsupdate=false
  add(SELF.bq,SELF.bq.id)
  loop loopcounter = 1 to numelements
    SELF.aq.controlnumber=controlnum + loopcounter-1
    SELF.aq.controltype=1
    SELF.aq.QID=SELF.bq.id
    add(SELF.aq,SELF.aq.controlnumber)
  end !loop

NewControl.Init PROCEDURE()
  CODE
  SELF.bq &= NEW boxqueue
  SELF.aq &= NEW allcontrols

NewControl.Kill PROCEDURE
loopcounter signed
  CODE
  loop loopcounter=1 to records(SELF.bq)
    get(SELF.bq,loopcounter)
    SELF.bq.cp.kill()
  end
  DISPOSE(SELF.bq)
  DISPOSE(SELF.aq)

NewControl.TakeEvent   PROCEDURE(SIGNED fieldnum)

ReturnValue          BYTE,AUTO
Looped BYTE
  CODE
  SELF.aq.ControlNumber=fieldnum                      !Try list events first
  get(SELF.aq,SELF.aq.ControlNumber)                  !Get the matching box
  if not error()
    case SELF.aq.controltype
    OF 1
      SELF.BQ.ID=SELF.AQ.QID                          !If is a list event
      get(SELF.BQ,SELF.BQ.ID)
      if not error()
        case SELF.bq.CP.TakeEvent(fieldnum)   !Check the return value: 1 = Drag; 2=Drop
        of 1
          SELF.bq.NeedsUpdate=True                    !Mark for later update on drop
          put(SELF.bq)                               !And update the queue
          if error() then message('error putting to newcontrol q ' & error()).
        of 2
          SELF.Refresh()                              !Do the marked updates
        end      !case
      else
        message('failed to find record in boxqueue')
      end
   else
     message('failed to find record in allcontrols queue')       
   end
 end
 return(Level:Benign)

NewControl.SaveSettings          PROCEDURE()
 code
 !save to ini file from queue and from related classes to go here

NewControl.RestoreSettings       PROCEDURE()
 code
 !restore from ini file to queue and to related classes to go here

NewControl.Refresh               PROCEDURE()
loopcounter short
  code
  !will loop through boxqueue and other controls and refresh those that are marked
  loop loopcounter = 1 to records(self.bq)
    get(self.bq,loopcounter)
    if self.bq.needsupdate
      self.bq.cp.resetqueue(1)
      self.bq.needsupdate=false
    end
  end
